Name:           ocaml-qtest
Version:        2.9
Release:        2%{?dist}
Summary:        Inline (Unit) Tests for OCaml

License:        GPLv3+
URL:            https://github.com/vincent-hugot/qtest
Source0:        https://github.com/vincent-hugot/qtest/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  ocaml
BuildRequires:  jbuilder
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ounit-devel >= 2.0.0
BuildRequires:  ocaml-qcheck >= 0.5
BuildRequires:  opam-installer
BuildRequires:  help2man


%description
qtest extracts inline unit tests written using a special syntax in
comments. Those tests are then run using the oUnit framework and the
qcheck library. The possibilities range from trivial tests -- extremely
simple to use -- to sophisticated random generation of test cases.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name}%{?_isa} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%setup -q -n qtest-%{version}


%build
jbuilder build @install


%install
export DESTDIR=$RPM_BUILD_ROOT
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $OCAMLFIND_DESTDIR
jbuilder install --destdir="$DESTDIR/usr" --libdir="$OCAMLFIND_DESTDIR" --verbose

# These files will be installed using the doc and license directives
rm $DESTDIR/usr/doc/qtest/{LICENSE,README.adoc}

# Makes *.cmxs executable such that they will be stripped.
find %{buildroot} -name '*.cmxs' -exec chmod 0755 {} \;

# generate manpage
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1/
help2man $RPM_BUILD_ROOT%{_bindir}/qtest \
    --output $RPM_BUILD_ROOT%{_mandir}/man1/qtest.1 \
    --name "Inline (Unit) Tests for OCaml" \
    --version-string %{version} \
    --no-info


%check
make test


%files
%doc README.adoc HOWTO.adoc
%license LICENSE
%{_bindir}/qtest
%{_mandir}/man1/qtest.1*
%{_libdir}/ocaml/qtest
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/qtest/lib/*.a
%exclude %{_libdir}/ocaml/qtest/lib/*.cmxa
%exclude %{_libdir}/ocaml/qtest/lib/*.cmx
%endif

%files devel
%doc README.adoc HOWTO.adoc
%license LICENSE
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qtest/lib/*.a
%{_libdir}/ocaml/qtest/lib/*.cmxa
%{_libdir}/ocaml/qtest/lib/*.cmx
%endif

%changelog
* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri May 18 2018 Andy Li <andy@onthewings.net> - 2.9-1
- New upstream release (RHBZ#1570332).
- Enable devel and debug packages.

* Fri Apr 06 2018 Andy Li <andy@onthewings.net> - 2.8-1
- New upstream release.
- Remove ocaml-qtest-LICENSE.patch which has been applied upstream.

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Nov 23 2017 Andy Li <andy@onthewings.net> - 2.7-1
- Initial RPM release.
